var StrayFiles = function()
{
	var sf = {};
	var debug = 0;

	var strayFolders;
	
	// Page initialization
	sf.initPage = function()
	{
		// Step 1
		Events.addEventHandler('pathFilter', 'change', sf.filterOnChange);
		Events.addEventHandler('serverFilter', 'change', sf.filterOnChange);
		Events.addEventHandler('dateFilter', 'change', sf.filterOnChange);
		Events.addEventHandler('ownerFilter', 'change', sf.filterOnChange);

		Buttons.addClickHandler('check_uncheck', sf.selectAll);
		
		Buttons.addClickHandler('btnDeleteStrayFolders', sf.deleteStrayFolders);

		// Navigation
		Buttons.addClickHandler('gocancel', Wizard.cancelWizard);
		Buttons.addClickHandler('gorestart', Wizard.restartWizard);
		Buttons.addClickHandler('gonext', Wizard.goNextOnClick);
		Buttons.addClickHandler('goregister', Wizard.goRegister);
		
		// Final registration
		Events.addEventHandler('wizard', 'wizard-submit', sf.submit);

		Wizard.showLoadingAnimation('Searching for stray folders...', 'stray-files-progress');
		var url = '../Admin.servlet?ID='+App.getSessionId();
		url += '&cmd=FindStrayFolders';
		Wizard.asyncJsonRequest(url, sf.initializeStep1);
	}
	
	// --- Step 1 -----------------------------------
	sf.initializeStep1 = function(response)
	{
		var frm = document.forms['reggie'];
		var fileServers = response.fileServers;
		var serverById = [];
		for (var serverNo = 0; serverNo < fileServers.length; serverNo++)
		{
			var fs = fileServers[serverNo];
			serverById['id-'+fs.id] = fs;
			fs.encodedName = Strings.encodeTags(fs.name);
			frm.serverFilter[frm.serverFilter.length] = new Option(fs.name, fs.id); 
		}
		
		strayFolders = response.strayFolders;
		var html = '';
		for (var strayNo = 0; strayNo < strayFolders.length; strayNo++)
		{
			var folder = strayFolders[strayNo];
			folder.include = true;
			folder.index = strayNo;
			var server = serverById['id-'+folder.fileServer];
			
			html += '<tr class="highlight" id="stray.'+strayNo+'">';
			html += '<td><span id="index.'+strayNo+'">'+(strayNo+1)+'</span> <input type="checkbox" name="check.'+strayNo+'" value="'+strayNo+'"></td>'
			html += '<td>';
			html += '<span class="link file-link" data-server="'+server.id+'" data-folder="'+Strings.encodeTags(folder.path)+'" title="View files in this folder"><img src="../images/remote_folder.png"></span>';
			html += Strings.encodeTags(folder.path);
			html += '</td>';
			html += '<td>'+server.encodedName+'</td>';
			html += '<td>' + Reggie.reformatDate(folder.lastModified) + '</td>';
			html += '<td>' + Strings.encodeTags(folder.owner) + '</td>';
			html += '</tr>';
		}

		Doc.element('strayFilesSection').innerHTML = html;
		Doc.element('num-stray').innerHTML = Reggie.formatCount(strayFolders.length);
		Doc.element('num-stray').title = strayFolders.length;
		Doc.element('num-total').innerHTML = Reggie.formatCount(response.totalFolders);
		Doc.element('num-total').title = response.totalFolders;
		
		// Add click handler to file links
		var clickableItems = document.getElementsByClassName('file-link');
		for (var i = 0; i < clickableItems.length; i++)
		{
			Events.addEventHandler(clickableItems[i], 'click', sf.fileLinkOnClick);
		}
		
		Doc.showHide('strayFilesSection', strayFolders.length > 0);
		Doc.showHide('no-stray-files', strayFolders.length==0);
		Doc.show('step-1');
	}
	
	sf.filterOnChange = function()
	{
		var frm = document.forms['reggie'];
		
		var filter = new Filter();

		filter.addTextCriteria(ItemProperty.Path, frm.pathFilter.value);
		filter.addNumericCriteria(ItemProperty.ServerId, frm.serverFilter.value);
		filter.addDateCriteria(ItemProperty.LastModified, frm.dateFilter.value);
		filter.addTextCriteria(ItemProperty.Owner, frm.ownerFilter.value);

		var numMatching = 0;
		for (var strayNo = 0; strayNo < strayFolders.length; strayNo++)
		{
			var folder = strayFolders[strayNo];
			
			folder.include = filter.check(folder);
			if (folder.include)
			{
				numMatching++;
				Doc.element('index.'+strayNo).innerHTML = numMatching;
				Doc.show('stray.'+strayNo);
			}
			else
			{
				Doc.hide('stray.'+strayNo);
			}
		}
		
		Doc.showHide('strayFilesSection', numMatching > 0);
		Doc.showHide('no-stray-files', numMatching==0);
	}
	
	
	sf.fileLinkOnClick = function(event)
	{
		var folder = Data.get(event.currentTarget, 'folder');
		var server = Data.get(event.currentTarget, 'server');
		var url = '../analysis/view_remote_files.jsp?ID=' + App.getSessionId();
		url += '&fileserver='+server;
		url += '&path='+encodeURIComponent(folder);
		Dialogs.openPopup(url, 'ViewStrayFiles', 750, 500);
	}

	
	sf.selectAll = function()
	{
		var frm = document.forms['reggie'];
		var firstChecked = null;
		for (var strayNo = 0; strayNo < strayFolders.length; strayNo++)
		{
			var sf = strayFolders[strayNo];
			var checkbox = frm['check.'+strayNo];
			if (sf.include && checkbox)
			{
				if (firstChecked == null)
				{
					firstChecked = checkbox.checked;
				}
				checkbox.checked = !firstChecked;
			}
		}
	}

	sf.checkSelected = function(filter, noneSelectedMsg)
	{
		var frm = document.forms['reggie'];
		var selected = [];
		
		for (var strayNo = 0; strayNo < strayFolders.length; strayNo++)
		{
			var folder = strayFolders[strayNo];
			if (folder.include && frm['check.'+strayNo] && frm['check.'+strayNo].checked)
			{
				if (!filter || filter.check(folder))
				selected[selected.length] = folder;
			}
		}
		
		if (selected.length == 0 && noneSelectedMsg)
		{
			Forms.showNotification('check_uncheck', noneSelectedMsg, null, 'pointer-below');
		}
		
		return selected;
	}

	sf.deleteStrayFolders = function(event)
	{
		var selected = sf.checkSelected(null, 'Select at least one folder');
		if (selected.length == 0) return;
		
		if (!confirm('Delete ' + selected.length + ' folders? This action can\'t be undone.'))
		{
			return;
		}
	
		var index = [];
		for (var i = 0; i < selected.length; i++)
		{
			index[i] = selected[i].index;
		}
		
		var submitInfo = {};
		submitInfo.cmd = 'DeleteStrayFolders';
		submitInfo.message = 'Deleting ' + selected.length + ' stray folders';
		submitInfo.folders = index;
		Wizard.goRegister(submitInfo);
	}

	
	sf.submit = function(event)
	{
		var submitInfo = event.detail;
		var url = '../Admin.servlet?ID='+App.getSessionId();
		url += '&cmd='+submitInfo.cmd;
		Wizard.showLoadingAnimation(submitInfo.message || 'Registering YellowLabel specimen...');
		Wizard.asyncJsonRequest(url, sf.submissionResults, 'POST', JSON.stringify(submitInfo));
	}
	
	sf.submissionResults = function(response)
	{
		Wizard.showFinalMessage(response.messages);
		Doc.show('gorestart');
	}

	return sf;
}();

Doc.onLoad(StrayFiles.initPage);

/**
	Holds one or more filter criterias. Use the 'add*' methods
	to add criterias to the filter, and the 'check(item)' method
	to evaluate all criterias against a single item.
*/
var Filter = function()
{
	this.criterias = [];
}

/**
	Adds a text criteria comparing the given item property to
	a static value (f2).
*/
Filter.prototype.addTextCriteria = function(itemProp, f2)
{
	if (f2 != '') 
	{
		this.criterias[this.criterias.length] = function(item) { return Comparator.contains(itemProp(item), f2) };
	}
}

/**
	Adds a numeric criteria comparing the given item property to
	a static value (f2). The 'f2' value may start with either '<' or '>'
	to compare with less than/greater than operators, otherwise
	it will use the 'approximately equals' operator.
*/
Filter.prototype.addNumericCriteria = function(itemProp, f2, factor)
{
	if (f2 != '')
	{
		var firstChar = f2.charAt(0);
		if (!firstChar.match(/[\d\-]/)) f2 = f2.substring(1);
	
		var cmp = Comparator.get(firstChar, Comparator.approx);
		var limit = parseFloat(f2);
		if (factor) limit *= factor;
	
		this.criterias[this.criterias.length] = function(item) { return cmp(itemProp(item), limit) };
	}
}

/**
	Adds a temporal criteria for comparing dates. The 'f2' value
	may start with either '<' or '>' to compare with earlier/later
	than operators. In all cases, the 'f2' value is stripped from '-'
	characters.
*/
Filter.prototype.addDateCriteria = function(itemProp, f2)
{
	if (f2 != '')
	{
		var firstChar = f2.charAt(0);
		if (firstChar == '<' || firstChar == '>') f2 = f2.substring(1);
		f2 = f2.replace(/\-/g, '');
		var cmp = Comparator.get(firstChar, Comparator.startsWith);
		this.criterias[this.criterias.length] = function(item) { return cmp(itemProp(item), f2) };
	}

}

/**
	Evaluate all criterias. Return true if all pass, false otherwise.
*/
Filter.prototype.check = function(item)
{
	for (var i = 0; i < this.criterias.length; i++)
	{
		if (!this.criterias[i](item)) return false;
	}
	return true;
}

/**
	Functions for extracting various properties from
	folder items. Each method accepts a single folder as a parameter
	and return a value from the folder item. The methods
	are used as parameters to Filter.add*Criteria() methods.
*/
var ItemProperty = function()
{
	var p = {};
	
	p.Path = function(item)
	{
		return item.path;
	}
	
	p.ServerId = function(item)
	{
		return item.fileServer;
	}
	
	p.LastModified = function(item)
	{
		return item.lastModified;
	}
	
	p.Owner = function(item)
	{
		return item.owner;
	}
	
	return p;
}();

/**
	Comparator functions for comparing two values.
*/
var Comparator = function()
{
	var cmp = {};
	
	/**
		Return a comparator based on the symbol
		which can be either '>' or '<' to return
		Comparator.gt or Comparator.lt. Otherwise
		the given default or Comparator.eq is returned.
	*/
	cmp.get = function(symbol, defaultCmp)
	{
		var c;
		if (symbol == '<')
		{
			c = cmp.lt;
		}
		else if (symbol == '>')
		{
			c = cmp.gt;
		}
		else
		{
			c = defaultCmp || cmp.eq;
		}
		return c;
	}
	
	// Compare if two values are equal
	cmp.eq = function(v1, v2)
	{
		return v1 == v2;
	}
	
	cmp.contains = function(v1, v2)
	{
		return v1 != null && v2 != null && v1.indexOf(v2) >= 0;
	}
	
	// Compare if two values are appoximately equals (difference is not more than 0.05)
	cmp.approx = function(v1, v2)
	{
		return Math.abs(v2 - v1) < 0.05;
	}
	
	// Compare if v1 starts with the same string as v2
	cmp.startsWith = function(v1, v2)
	{
		return v1 != null && v1.indexOf(v2) == 0;
	}
	
	// Compare if v1 is greater than or equal to v2
	cmp.gt = function(v1, v2)
	{
		return v1 != null && v2 != null && v1 >= v2;
	}
	
	// Compare if v1 is less than or equal to v2
	cmp.lt = function(v1, v2)
	{
		return v1 != null && v2 != null && v1 <= v2;
	}
	
	return cmp;
}();
