<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.util.formatter.DateFormatter"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, "net.sf.basedb.reggie", true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
final Formatter dateFormat = new DateFormatter("yyyyMMdd");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head 
	scripts="linkitems-2.js,~../reggie-2.js,~register.js" 
	styles="path.css,~../css/reggie-2.css"
>
<style>

</style>
</base:head>
<base:body>

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Register sample outtake" 
		/></p:path>

	<div class="content">

	<form name="reggie" id="wizard" class="wizard">
	<input type="hidden" name="ID" value="<%=ID%>">
	
	<div class="step" id="step-1">
		<div class="step-no">1</div>
		<div class="step-title">Select an outtake work list</div>
		<div class="step-content">

			<table class="step-form">
			<tr>
				<td class="prompt">Outtake work list</td>
				<td class="input">
					<select name="workList" id="workList" class="required auto-init"
						data-auto-init="focus-on-enter" data-next-focus="completedDate"></select>
				</td>
				<td class="status" id="workList.status"></td>
				<td class="help">
					<span id="workList.message" class="message"></span>
					Select an existing outtake work list.
				</td>
			</tr>
			<tr>
				<td class="prompt">Completed date</td>
				<td class="input">
					<input type="text" name="completedDate" id="completedDate"
						value="<%=dateFormat.format(new Date()) %>" 
						class="required auto-init" data-auto-init="focus-on-enter" data-next-focus="comments"
						style="width: 8em;" maxlength="10">
						<base:icon 
							id="completedDateCalendar"
							subclass="auto-init"
							data-auto-init="calendar"
							data-textarea-id="completedDate"
							data-date-format="yyyyMMdd"
							data-title="Completed date"
							image="calendar.png" 
							tooltip="Select a date from a calendar" 
							tabindex="-1"
						/>
				</td>
				<td class="status" id="completedDate.status"></td>
				<td class="help">
					<span id="completedDate.message" class="message"></span>
					(YYYYMMDD or MMDD) The date when the outtake was completed.
				</td>
			</tr>
			<tr class="align-top">
				<td class="prompt">Outcome</td>
				<td class="input">
					<label><input type="radio" name="outcome" id="outcomeSuccess" 
						checked>Success</label> - the outtake was completed as planned<br>
						
					<label><input type="radio" name="outcome" id="outcomeFailed" 
						>Failure</label> - the outtake could not be completed
				</td>
				<td class="status"></td>
				<td class="help">
					Select the <b>Success</b> option if all samples could be handled as planned.
					Use the <b>Failure</b> option if the outtake could not be completed. In
					the next step it is possible to specify if sample biomaterial was consumed
					or not.
				</td>
			</tr>
			<tr class="align-top">
				<td class="prompt">Comments</td>
				<td class="input"><textarea name="comments" id="comments" rows="6"></textarea></td>
				<td class="status" id="comments.status"></td>
				<td class="help">
					<span id="comments.message" class="message"></span>
					Comments about the outtake.
				</td>
			</tr>
			</table>
		</div>
	</div>
	
	<div class="step" id="step-2">
		<div class="step-no">2</div>
		<div class="step-title">Outtake failed</div>
		<div class="step-content">

			<table class="step-form">
			<tr>
				<td class="prompt">Sample consumed?</td>
				<td class="input">
					<label><input type="radio" name="sampleConsumed" id="sampleConsumedNo" checked value="0">For no items</label><br>
					<label><input type="radio" name="sampleConsumed" id="sampleConsumedYes" value="1">For all items</label><br>
				</td>
				<td class="status" id="sampleConsumed.status"></td>
				<td class="help">
					<span id="sampleConsumed.message" class="message"></span>
					Specify is biomaterial was consumed for the source items.
				</td>
			</tr>
			<tr class="align-top">
				<td class="subprompt">Except</td>
				<td class="input">
					<div class="selectionlist">
					<table style="width:100%;">
					<tr>
						<td style="width: 80%;">
						<select name="except" id="except"
							class="auto-init"
							data-auto-init="link-container"
							size="8" multiple>
						</select>
						</td>
						<td style="vertical-align: top;">
							<base:buttongroup vertical="true">
								<base:button 
									id="btnBrowseExcept"
									subclass="leftaligned"
									style="width: 8em;"
									title="Select&hellip;" 
									tooltip="Select biomaterial"
								/>
								<base:button 
									id="btnRemoveExcept"
									subclass="leftaligned auto-init"
									style="width: 8em;"
									data-auto-init="remove-link"
									data-list-id="except"
									title="Remove" 
									tooltip="Remove the selected biomaterial"
								/>
							</base:buttongroup>
						</td>
					</tr>
					</table>
					</div>

				</td>
				<td class="status" id="except.status"></td>
				<td class="help">
					<span id="except.message" class="message"></span>
					Specify all items that are an exepction to the <b>Sample consumed</b> option.
				</td>
			</tr>
			</table>
			
		</div>
	</div>
	
	<div id="wizard-status"></div>
	
	<table class="navigation" id="navigation">
	<tr>
		<td><base:button id="gocancel" title="Cancel" /></td>
		<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" /></td>
		<td><base:button id="goregister" title="Register" image="<%=home+"/images/import.png"%>"  /></td>
		<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" /></td>
		<td id="gonext-message" class="message"></td>
	</tr>
	</table>
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>