var Istat = function()
{
	var istat = {};
	var debug = 0;
	
	var refStartScanbIdPure;
	var caseIsValid = false;

	istat.initPage = function()
	{
		// Step 1
		Events.addEventHandler('step-1', 'wizard-validate', istat.validateStep1);
		Events.addEventHandler('sites', 'change', istat.siteAndVariantOnChange);
		Events.addEventHandler('referralvariant', 'change', istat.siteAndVariantOnChange);
		Buttons.addClickHandler('gonext', Wizard.goNextOnClick);
		
		// Step 2
		Events.addEventHandler('step-2', 'wizard-validate', istat.validateStep2);
		Events.addEventHandler('caseName', 'keypress', Wizard.focusOnEnter);
		Events.addEventHandler('caseName', 'blur', istat.caseNameOnChange);
		
		// Step 3
		Buttons.addClickHandler('downloadformbatch1', istat.downloadFormBatch1);
		Buttons.addClickHandler('downloadformbatch2', istat.downloadFormBatch2);
		Buttons.addClickHandler('updateusedscanbidlist', istat.updateUsedScanbIdList);
		
		// Navigation
		Buttons.addClickHandler('gocancel', Wizard.cancelWizard);
		Buttons.addClickHandler('gorestart', Wizard.restartWizard);

		Doc.show('step-1');
		Doc.show('gonext');
		Doc.addClass('gonext', 'disabled');

		refStartScanbIdPure = '';

		// Load sites
		var frm = document.forms['reggie'];
		var url = '../ScanBQuarterMonthReport.servlet?ID='+App.getSessionId();
		url += '&cmd=GetSites';		
		Doc.addClass('sites', 'list-loading');
		frm.sites[0] = new Option('loading...');
		Wizard.asyncJsonRequest(url, istat.sitesLoaded);
	}
	
	istat.sitesLoaded = function(response)
	{
		Doc.removeClass('sites', 'list-loading');
		var frm = document.forms['reggie'];
		var sites = response.sites;
		frm.sites.length = 0;
		//frm.sites[0] = new Option('All sites together', '');
		frm.sites[0] = new Option('- Select site -', '');
		for (var i = 0; i < sites.length; i++)
		{
			var s = sites[i];
			//var option = new Option(s.name, s.prefix);
			var option = new Option(s.name + '  [' + s.prefix + ']', s.prefix);
			frm.sites[frm.sites.length] = option;
		}
	}

	istat.siteAndVariantOnChange = function()
	{
		var frm = document.forms['reggie'];
		var site = frm.sites.value;
		var refVariant = frm.referralvariant.value;
		var siteAndVariantAreValid = false;
		if (site != '' && refVariant != '')
		{
			siteAndVariantAreValid = true;
		}
		if (siteAndVariantAreValid)
		{
			// Check if multiple template files for same referral from type
			var url = '../ReferralGenerator.servlet?ID='+App.getSessionId();
			url += '&cmd=GetReferralTemplateInfo';
			url += '&site='+encodeURIComponent(site);
			url += '&referralvariant='+encodeURIComponent(refVariant);
			Wizard.showLoadingAnimation('Getting referral template info...', 'ref-gen-progress');
			Wizard.asyncJsonRequest(url, istat.preValidateStep1);
		}
		else
		{
			Doc.addClass('gonext', 'disabled');
		}
	}

	istat.preValidateStep1 = function(response)
	{
		var frm = document.forms['reggie'];

		var jsonMultTemplates = response.multTemplates;
		if (jsonMultTemplates.length > 0)
		{
			// List multiple templates/type
			//var html = '<table id="templateFilesTable" class="step-form">';
			var html = '<br>';
			html += '<table id="templateFilesTable">';
			// Header row
			html += '<tr>';
			html += '<th>Multiple template files for same type</th>';
			html += '<th>Template type</th>';
			html += '</tr>';
			// File list
			for (var i = 0; i < jsonMultTemplates.length; i++)
			{
				//var filename = jsonMultTemplates[i];
				var jsonMultTempl = jsonMultTemplates[i];
				var filename = jsonMultTempl['file'];
				var type = jsonMultTempl['type'];
				html += '<tr>';
				html += '<td>&nbsp;&nbsp;' + filename + '</td>';
				html += '<td>&nbsp;&nbsp;' + type + '</td>';
				html += '</tr>';
			}
			html += '</table>';
			Doc.element('step1message').innerHTML = html;

			// Display extra checkbox to confirm use of multiple templates/type
			var confirmMsg = 'Check to verify use of multiple template files for same type.';
			Wizard.showGoNextConfirmation(true, confirmMsg);
			return;
		}
		else
		{
			Doc.removeClass('gonext', 'disabled');
		}
	}

	istat.validateStep1 = function(event)
	{
		istat.initializeStep2();
	}

	istat.initializeStep2 = function(response)
	{
		var frm = document.forms['reggie'];
		Wizard.setCurrentStep(2);

		istat.selectOptionsDisabled('sites', true);
		istat.selectOptionsDisabled('referralvariant', true);

		// Get referral start info
		var url = '../ReferralGenerator.servlet?ID='+App.getSessionId();
		url += '&cmd=GetReferralStartInfo';
		Wizard.showLoadingAnimation('Getting referral start info...', 'ref-gen-progress');
		Wizard.asyncJsonRequest(url, istat.initializeStep2a);
	}
		
	istat.initializeStep2a = function(response)
	{
		var frm = document.forms['reggie'];

		var jsonRefStartInfo = response.refStartInfo;
		
		var site = frm.sites.value;
		var refVariant = frm.referralvariant.value;

		// Initialize number of referral forms to generate
		var nofFormSetsDefault = 50;
		if (refVariant == 'kit2_neoadjuvant')
		{
			nofFormSetsDefault = 25;
		}
		frm.nofFormSets.value = nofFormSetsDefault;		
		
		refStartScanbIdPure = jsonRefStartInfo['startScanbIdPure'];
		var lastUpdated = jsonRefStartInfo['lastUpdated'];
		// Add site prefix to referral pure start SCAN-B id
		var refStartScanbId = site + refStartScanbIdPure;
		if (lastUpdated != null && lastUpdated != '')
		{
			Doc.element('scanbIdLastUpdated').innerHTML = lastUpdated;
		}
		frm.caseName.value = refStartScanbId;

		Doc.show('gonext');

		Doc.show('step-2');
	}

	istat.caseNameOnChange = function()
	{
		var frm = document.forms['reggie'];
		var caseName = frm.caseName.value.toUpperCase();
		caseIsValid = false;
		Doc.addClass('gonext', 'disabled');
		if (caseName == '')
		{
			Wizard.setInputStatus('caseName', 'invalid', 'Missing');
			frm.caseName.focus();
			return;
		}
		if (!Reggie.isValidCaseName(caseName, true)) // Allow C/D suffix to be used
		{
			Wizard.setInputStatus('caseName', 'invalid', 'Only 7-digits name + optional \'C\' or \'D\' is allowed.');
			frm.caseName.focus();
			return;
		}
		// Check if pure case name < stored next pure case name
		var curRefStartScanbIdPure = caseName.substring(2);
		if (curRefStartScanbIdPure < refStartScanbIdPure)
		{
			var confirmMsg = 'Check to verify use of pure SCAN-B ID < ' + refStartScanbIdPure + ' (stored value).';
			Wizard.showGoNextConfirmation(true, confirmMsg);
			return;
		}

		frm.caseName.value = caseName;
		Wizard.setInputStatus('caseName', 'valid');
		caseIsValid = true;
		Doc.removeClass('gonext', 'disabled');
	}

	istat.validateStep2 = function(event)
	{
		var valid = true;
		valid &= Wizard.isValid('caseName');
		if (!valid) event.preventDefault();

		istat.generateReferralForms();
	}

	istat.generateReferralForms = function()
	{
		var frm = document.forms['reggie'];
		var refVariant = frm.referralvariant.value;
		var startCaseName = frm.caseName.value;
		var nofFormSets = frm.nofFormSets.value;

		Doc.addClass('caseName', 'disabled');
		Doc.addClass('nofFormSets', 'disabled');

		Doc.hide('gonext');

		var url = '../ReferralGenerator.servlet?ID='+App.getSessionId();
		url += '&cmd=GenerateReferralForms';
		url += '&referralvariant='+encodeURIComponent(refVariant);
		url += '&startcasename='+encodeURIComponent(startCaseName);
		url += '&nofformsets='+encodeURIComponent(nofFormSets);

		Wizard.showLoadingAnimation('Generating referral forms...', 'ref-gen-progress');
		Wizard.asyncJsonRequest(url, istat.initializeStep3);
/*
		// POST
		Wizard.showLoadingAnimation('Generating referral forms...', 'ref-gen-progress');
		Wizard.asyncJsonRequest(url, istat.initializeStep2, 'POST', formData);
*/
	}

	istat.initializeStep3 = function(response)
	{
		var frm = document.forms['reggie'];
		Wizard.setCurrentStep(3);
		Wizard.showFinalMessage(response.messages);

		Doc.hide('gonext');
		Doc.show('downloadformbatch1');
		Doc.show('downloadformbatch2');
		Doc.show('updateusedscanbidlist');
	
		Doc.show('step-3');
	}
		
	istat.initializeStep3a = function(response)
	{
		var frm = document.forms['reggie'];
		Wizard.setCurrentStep(3);
		Wizard.showFinalMessage(response.messages);

		Doc.show('gorestart');
		Doc.hide('gonext');
		Doc.show('downloadformbatch1');
		Doc.show('downloadformbatch2');
		Doc.show('updateusedscanbidlist');
		Doc.addClass('updateusedscanbidlist', 'disabled');
	
		Doc.show('step-3');
	}
		
	istat.downloadFormBatch1 = function()
	{
		istat.downloadFormBatch(1);
	}

	istat.downloadFormBatch2 = function()
	{
		istat.downloadFormBatch(2);
	}

	istat.downloadFormBatch = function(batchType)
	{
		var frm = document.forms['reggie'];
		var startCaseName = frm.caseName.value;
		var nofFormSets = frm.nofFormSets.value;

		var url = '../ReferralGenerator.servlet?ID='+App.getSessionId();
		url += '&cmd=DownloadFormBatchFile';
		url += '&batchType='+batchType;
		url += '&startcasename='+encodeURIComponent(startCaseName);
		url += '&nofformsets='+encodeURIComponent(nofFormSets);
		window.open(url);
	}

	istat.updateUsedScanbIdList = function()
	{
		var frm = document.forms['reggie'];
		var startCaseName = frm.caseName.value;
		var nofFormSets = frm.nofFormSets.value;

		var url = '../ReferralGenerator.servlet?ID='+App.getSessionId();
		url += '&cmd=UpdateUsedScanbIdList';
		url += '&startcasename='+encodeURIComponent(startCaseName);
		url += '&nofformsets='+encodeURIComponent(nofFormSets);

		Wizard.asyncJsonRequest(url, istat.initializeStep3a);
	}

	istat.selectOptionsDisabled = function(id, value)
	{
		var op = document.getElementById(id).getElementsByTagName('option');
		for (var i = 0; i < op.length; i++)
		{
			op[i].disabled = value;
		}
	}

	return istat;
}();

Doc.onLoad(Istat.initPage);

